import { BrowserModule } from '@angular/platform-browser';
import { NgModule } from '@angular/core';
import { StoreModule } from '@ngrx/store';
import { StoreDevtoolsModule } from '@ngrx/store-devtools';

import { AppComponent } from './app.component';
import { PreviewComponent } from './preview/preview.component';
import { DynamicFormModule } from './dynamic-form/dynamic-form.module';
import { FormBuilderModule } from './form-builder/form-builder.module';
import { questionsReducer } from './store/question.reducer';
import { QuestionControlService } from './dynamic-form/question-control.service';
import { MaterialModule } from './material';


@NgModule({
  declarations: [
    AppComponent,
    PreviewComponent,
  ],
  imports: [
    BrowserModule,

    DynamicFormModule,
    FormBuilderModule,
    MaterialModule,
    StoreModule.forRoot({
      questionsReducer: questionsReducer
    }),
    StoreDevtoolsModule.instrument({
      maxAge: 30
    })
  ],
  providers: [QuestionControlService],
  bootstrap: [AppComponent]
})
export class AppModule { }
