import { Component, Input, OnInit, OnChanges, SimpleChanges } from '@angular/core';
import { FormGroup, } from '@angular/forms';

import { QuestionControlService } from './question-control.service';
import { Section } from '../models/question';

@Component({
    selector: 'app-dynamic-form',
    templateUrl: './dynamic-form.component.html',
    providers: [QuestionControlService]
})
export class DynamicFormComponent implements OnInit, OnChanges {

    @Input() sections: Section[] = [];
    @Input() form: FormGroup = new FormGroup({});
    payLoad = '';

    constructor(private qcs: QuestionControlService) {
    }

    ngOnInit() {
        console.log('form initialized', this.sections);
        this.generateFormGroup();
    }

    ngOnChanges(changes: SimpleChanges) {
        console.log('form changed', this.sections);
        this.generateFormGroup();
    }

    private generateFormGroup() {
        if (this.form) {
            this.form = new FormGroup({});
        }
        this.form = this.qcs.toFormGroup(this.sections);
    }

    onSubmit() {
        this.payLoad = this.form.value;
        debugger;
    }
}
