import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

import { ReactiveFormsModule } from '@angular/forms';
import { DynamicFormComponent } from './dynamic-form.component';
import { DynamicFormQuestionComponent } from './dynamic-form-question.component';
import { SectionComponent } from './section/section.component';
import { DebugPipe } from '../utility/debug.pipe';
import { ColumnComponent } from './column/column.component';
import { QuestionBasePipe } from './questionBase.pipe';

@NgModule({
  imports: [
    CommonModule,
    ReactiveFormsModule
  ],
  declarations: [
    DynamicFormComponent,
    DynamicFormQuestionComponent,
    SectionComponent,
    DebugPipe,
    QuestionBasePipe,
    ColumnComponent
  ],
  exports: [
    DynamicFormComponent,
    DebugPipe
  ]
})
export class DynamicFormModule { }
