import { Injectable } from '@angular/core';
import { FormControl, FormGroup, Validators } from '@angular/forms';
import { Section } from '../models/question';

@Injectable()
export class QuestionControlService {
    constructor() { }

    toFormGroup(sections: Section[]) {
        const group: any = {};
        sections.forEach(section => {
            const sectGroup = {};
            const questionsAr = [];
            const columns = section.columns;
            columns.forEach(column => {
                questionsAr.push(column.questions);
            });
            questionsAr.forEach(questions => {
                questions.forEach(question => {
                    sectGroup[question.key] = (!!question.required)
                    ? new FormControl(question.value, Validators.required)
                    : new FormControl(question.value);
                });
            });
            group[section.name] = new FormGroup(sectGroup);
        });
        return new FormGroup(group);
    }
}
