import { Component, OnInit, Input, Output } from '@angular/core';
import { Section } from '../../models/question';
import { EventEmitter } from '@angular/core';

@Component({
  selector: 'app-canvas-section',
  templateUrl: './canvas-section.component.html',
  styleUrls: ['./canvas-section.component.css']
})
export class CanvasSectionComponent implements OnInit {

  @Input() section: Section;
  @Output() delete = new EventEmitter();

  constructor() { }

  ngOnInit() {
  }

  deleteSection() {
    this.delete.emit(this.section);
  }

  deleteColumn(column) {
    const index = this.section.columns.indexOf(column);
    this.section.columns.splice(index, 1);
  }

}
