import { Component, OnInit, ViewChild, TemplateRef} from '@angular/core';
import { QuestionService } from '../../dynamic-form/question.service';
import { DragulaService } from 'ng2-dragula';
import { Store } from '@ngrx/store';
import { IAppState } from '../../store/question.reducer';
import { QuestionActions } from '../../store/question.reducer';
import { Section } from '../../models/question';
import { CanvasComponent } from '../canvas/canvas.component';
import { MatDialog } from '@angular/material';
import { FormGroup, FormControl, Validators, FormBuilder, FormArray } from '@angular/forms';


@Component({
  selector: 'app-edit-questions',
  templateUrl: './edit-questions.component.html',
  styleUrls: ['./edit-questions.component.css']
})
export class EditQuestionsComponent implements OnInit {
  public keyValueForm: FormGroup;
  selectedValue:string ='';
  addQuestion: FormGroup;
  submitted = false;
  data: Section[] = [];
  @ViewChild('canvas') canvas: CanvasComponent;

  constructor(
    private qs: QuestionService,
    private ds: DragulaService,
    private store: Store<IAppState>,
    public dialog: MatDialog,
    private formBuilder: FormBuilder) {
      const items = [];
    items.push(this.formBuilder.group({
      key: new FormControl(''),
      value: new FormControl('')
    }));


    this.keyValueForm = this.formBuilder.group({
      details: this.formBuilder.array(items)
    });

    }
   

  ngOnInit() {
    // this.editQuestionFields = this.qs.getQuestionsFromApi();
    // this.ds.dropModel('FIELDS').subscribe(({ sourceModel, targetModel, item }) => {
    //   this.store.dispatch(new QuestionActions(targetModel));
    // });
    // getting previous data from api and setting canvas
    this.data = this.qs.getComplexQuestionFromApi();
    this.addQuestion = this.formBuilder.group({
      controlType : new FormControl('', Validators.required),
      placeholder : new FormControl('', Validators.required),
      required : new FormControl('', Validators.required),
      label : new FormControl('', Validators.required)
      // optionsKey : new FormControl('', Validators.required),
      // optionsValue : new FormControl('', Validators.required)
    }); 
  }

  preview() {
    this.store.dispatch(new QuestionActions(this.canvas.data));
  }
  
  openDialogWithTemplateRef(templateRef: TemplateRef<any>) {
    this.dialog.open(templateRef, {
      height:'650px',
      width: '650px',
      autoFocus: false

    }
      );
  }
  
  get f() { return this.addQuestion.controls; }
 
//   onFormSubmit(): void {
//     console.log('input:' + this.userForm.get('controlType').value);
//     console.log('label:' + this.userForm.get('label').value);
//     console.log('placeholder:' + this.userForm.get('placeholder').value);
//     console.log('required:' + this.userForm.get('required').value);
// } 

onSubmit() {
  this.submitted = true;
  if (this.addQuestion.invalid) {
      return;
  }
    
    this.qs.setFormQuestions(this.addQuestion.value);
    debugger;
  // alert('SUCCESS!! \n\n' + JSON.stringify(this.addQuestion.value));
}
addRow() {
  const details = this.keyValueForm.get('details') as FormArray;
  details.push(this.createItem());
}

removeRow(index) {
  const details = this.keyValueForm.get('details') as FormArray;
  details.removeAt(index);
}

createItem(): FormGroup {
  return this.formBuilder.group({
    key: [],
    value: []
  });
}

}

