import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { DragulaModule } from 'ng2-dragula';
import { ModalModule, BsModalService } from 'ngx-bootstrap';
import { MaterialModule } from 'src/app/material';
import { FormBuilderComponent } from './form-builder.component';
import { QuestionService } from '../dynamic-form/question.service';
import { FieldsComponent } from './fields/fields.component';
import { EditQuestionsComponent } from './edit-questions/edit-questions.component';
import { CanvasComponent } from './canvas/canvas.component';
import { CanvasSectionComponent } from './canvas-section/canvas-section.component';
import { CanvasColumnComponent } from './canvas-column/canvas-column.component';
import { CanvasQuestionComponent } from './canvas-question/canvas-question.component';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';

@NgModule({
  imports: [
    CommonModule,
    DragulaModule.forRoot(),
    ModalModule.forRoot(),
    FormsModule,
    ReactiveFormsModule,
    MaterialModule,
    BrowserAnimationsModule,
  ],
  declarations: [
    FormBuilderComponent,
    FieldsComponent,
    EditQuestionsComponent,
    CanvasComponent,
    CanvasSectionComponent,
    CanvasColumnComponent,
    CanvasQuestionComponent
  ],
  exports: [FormBuilderComponent],
  providers: [QuestionService, BsModalService]
})
export class FormBuilderModule { }
