import { FormGroup } from '@angular/forms';

export interface Section {
    heading: string;
    name: string;
    css?: string;
    columns: Column[];
}

export interface Column {
    css?: string;
    questions: Question[];
}

export interface Question {
    controlType: string;
    key: string;
    label: string;
    order: number;
    value?: string;
    required?: boolean;
    type?: string;
    options?: SelectOptions[];
    css?: string;
    regex?: string;
    index?: {
        row: number;
        column: number;
    };
}

interface SelectOptions {
    key: string;
    value: string;
}

export interface QuestionData {
    sections: Section[];
    form: FormGroup;
}
