import { Component, OnInit, OnChanges } from '@angular/core';
import { Store, select } from '@ngrx/store';
import { IAppState } from '../store/question.reducer';
import { Section, QuestionData } from '../models/question';
import { QuestionControlService } from '../dynamic-form/question-control.service';
import { FormGroup } from '@angular/forms';
import { QuestionService } from '../dynamic-form/question.service';

@Component({
  selector: 'app-preview',
  templateUrl: './preview.component.html',
  styleUrls: ['./preview.component.css']
})
export class PreviewComponent implements OnInit {

  data: QuestionData = null;
  sections: Section[] = [];
  form: FormGroup = new FormGroup({});

  constructor(private store: Store<IAppState>, private qcs: QuestionControlService, private qs: QuestionService) {
  }

  ngOnInit() {

    // this.data = this.qs.getComplexQuestionFromApi();

    // dynamically load questions from api
    // this.questions = this.qs.convertQuestions(this.qs.getQuestionsFromApi());

    // dynamically load questions from store
    // this.questions = [];
    // this.store.select('questionsReducer').pipe(
    //   select('questions')
    // ).subscribe(data => {
    //   console.log('questions', JSON.stringify(data));
    //   this.questions = data;
    // });

    this.store.select('questionsReducer')
      .subscribe(data => {
        console.log('new data received', data.sections);
        this.form = this.qcs.toFormGroup(data.sections);
        this.sections = data.sections;
      });
  }

}
