import { Action } from '@ngrx/store';
import { Section } from '../models/question';

export interface IAppState {
    sections: Section[];
}

const defaultState: IAppState = {
    sections: []
};

export const ADD_QUESTION = 'ADD_QUESTION';

export class QuestionActions implements Action {
    readonly type = ADD_QUESTION;
    constructor(public payLoad) {
    }
}

export function questionsReducer(state: IAppState = defaultState, action: QuestionActions): IAppState {
    if (action.type === ADD_QUESTION) {
        return Object.assign({}, { sections: action.payLoad });
    }
    return state;
}
